# copyright: Huynh Duong Phuong Vi
# www.sketchupforyou.com
module S4U
    def self.get_file(dir_s4u_name,s4u_name,ext=".txt")
        file_name = s4u_name + ext
        file_name_full = File.join dir_s4u_name,file_name
        if File.exist?(file_name_full)
            file= File.new(file_name_full,"r")
            str=file.readlines
            file.close
            return str.collect{|s| s.chomp}
        end
        return false
        rescue=>error
            p error,error.backtrace.join('\n')
            return false
    end
    def self.set_file(dir_s4u_name,s4u_name,list,ext=".txt")
        file_name = s4u_name + ext
        file_name_full = File.join dir_s4u_name,file_name
        file= File.new(file_name_full, mode: 'w:UTF-8')
        str=list.join("\n")
        file.syswrite str
        file.close
        return true
        rescue=>error
            p error,error.backtrace.join('\n')
            return false
    end
	module S4u_mirror
		@setting=[]
		class Mirror
			def initialize(mirror_mode=0)
				@scale_factor= Sketchup.version.to_i > 17 ? UI.scale_factor : 1
				@scale_factor = 1.5 if @scale_factor>1.8
				@snap=20*@scale_factor
				@mirror_mode=mirror_mode
                @mirror_mode_list=[Strings["Mirror"],Strings["Mirror-Duplicate"]]
				@plane_type_list=[Strings["Set plane 2 points"],Strings["Set plane 3 points"],Strings["Set plane by Object"]]
			end
			def activate
				@edit_transform=Sketchup.active_model.axes.transformation
				@ip1=Sketchup::InputPoint.new
				@ip2=Sketchup::InputPoint.new
				@ip3=Sketchup::InputPoint.new
				@ip=Sketchup::InputPoint.new
				@middle_points=false
				@plane=nil
				@points=[]
                @elements=[]
                @entities=[]
                self.get_setting()
				self.reset(Sketchup.active_model.active_view)
			end
			def getExtents
				bb = Sketchup.active_model.bounds
				bb.add @ip.position if @ip.valid?
				bb.add @ip1.position if @ip1.valid?
				bb.add @ip2.position if @ip2.valid?
				bb.add @ip3.position if @ip3.valid?
				return bb
			end
			def get_setting()
                @setting = S4U::S4u_mirror::instance_variable_get :@setting
				if @setting && (@setting.class==Hash)
					@plane_type=@setting["@plane_type"]
					@mirror_mode=@setting["@mirror_mode"]
                else
                    @mirror_mode=0
                    @plane_type=0
					if s=S4U::get_file(Dir_s4u_name,NAME)
                        @setting=JSON.parse s[0]
                        @plane_type=@setting["@plane_type"]
						@mirror_mode=@setting["@mirror_mode"]
					end
                end
                rescue=>error
					@mirror_mode=0
					p error,error.backtrace.join('\n')
			end
			def deactivate(view)
                if @plane_type && @mirror_mode
                    @setting={}
                    @setting["@plane_type"]=@plane_type
                    @setting["@mirror_mode"]=@mirror_mode
                    S4U::S4u_mirror::instance_variable_set(:@setting,@setting)
                    (puts "error save setting") if !S4U::set_file(Dir_s4u_name,NAME,[@setting.to_json])
                end
                rescue=>error
                    p error,error.backtrace.join('\n')
			end
			def setstatus(view=nil)
				text = Strings["Mirror Mode"] + ": "
				text+= @mirror_mode_list[@mirror_mode].upcase + " | "
				text+= @plane_type_list[@plane_type] + " | "
				if @state==0
					if @middle_points
						if @points.length==0
							text+=Strings["Select First point of Middle"]
						elsif @points.length==1
							text+=Strings["Select Second point of Middle"]
						end
					else
						text+=Strings["Select First point"]
					end
				elsif @state==1
					if @middle_points
						if @points.length==0
							text+=Strings["Select First point of Middle"]
						elsif @points.length==1
							text+=Strings["Select Second point of Middle"]
						end
					else
						text+= Strings["Select Second point"]
					end
				elsif @state==2 && @plane_type==1
					if @middle_points
						if @points.length==0
							text+=Strings["Select First point of Middle"]
						elsif @points.length==1
							text+=Strings["Select Second point of Middle"]
						end
					else
						text+= Strings["Select Third point"]
					end
				elsif @state==2 && @plane_type==2
					text+= Strings["Select Object"]
				end
				Sketchup.status_text=text
				view.invalidate if view
			end
			def draw(view)
					view.line_width=2
					#view.drawing_color= "red"
					if @ip && @ip.valid?
						if @edge
							view.draw_points @ip.position, 15*@scale_factor, 1, "red"
						elsif @point
							view.draw_points @ip.position, 15*@scale_factor, 1, "red"
						elsif @ip.display?
							@ip.draw(view)
						end
					end
					if @state==1
						if @ip.valid?
							@ip.draw(view)
							if @p_shift
								view.line_stipple = "."
								view.drawing_color ="blue"
								view.draw_line(@ip.position, @ip2.position)
								view.line_stipple = ""
								p2_line=@ip.position.project_to_line([@ip1.position,@p_shift])
								view.draw_points p2_line, 10*@scale_factor, 2, "red"  if p2_line
								view.drawing_color = @plane_type==0 ? "red" : "blue"
								view.draw2d GL_LINES,[view.screen_coords(@ip1.position),view.screen_coords(p2_line)]
							else
								if @plane_type==0 && @ip2.valid? && @ip1.valid?
									view.line_width=4
									view.drawing_color ="red"
									#view = view.set_color_from_line @ip1.position, @ip2.position
									view.drawing_color ="magenta" if @line45
									ip = @ip2.position
									ip1=@point1 ? @point1 : @ip1.position
									view.draw2d GL_LINES,[view.screen_coords(ip),view.screen_coords(ip1)]
									v=(ip1-ip)
									if v.length!=0 && !(v.samedirection?(Z_AXIS) || v.samedirection?(Z_AXIS.reverse))
										vec=Z_AXIS.clone
										vec.length=10
										size = view.pixels_to_model @snap, ip
										vec.length=size if size>0
										view.line_width=2
										view.draw_polyline [(ip),(ip1),
										(ip1+vec),(ip+vec),(ip)]
									end
								elsif @plane_type==1
									view.drawing_color ="blue"
									view.draw_line @ip.position,@ip1.position
								end
							end
						end
					elsif @state==2
						@ip1.draw(view)
						@ip2.draw(view)
						view.drawing_color="blue"
						view.line_width=3
						view.draw_line @ip1.position,@ip2.position
						if @ip3.valid?
							@ip3.draw(view)
							view.drawing_color="#f3162b"
							view.draw GL_TRIANGLES,[(@ip1.position),(@ip2.position),(@ip3.position)]
							view.drawing_color="blue"
							view.line_width=3
							view.draw_line @ip2.position,@ip3.position
							view.draw_line @ip1.position,@ip3.position
						end
					elsif @state==0 || @alt_press
						if (@plane_type==2 || @alt_press) && @ip.valid? && @plane_transform
							view.drawing_color ="blue"
							view.line_width=4
							if @ip && @trans
								p=@ip.position
								length = view.pixels_to_model 15*@scale_factor, p
								vx=@plane_transform.xaxis;vy=@plane_transform.yaxis
								vx.length=vy.length=length
								p1=p+(vx+vy)
								p2=p+(vx.reverse+vy)
								p3=p+(vx.reverse+vy.reverse)
								p4=p+(vx+vy.reverse)
								view.line_width=1
								view.draw_polyline [p1,p2,p3,p4,p1]
								view.draw GL_QUADS,[p1,p2,p3,p4]
							end
						end
					end
					if @edge_preview && !@edge_preview.empty?
						view.line_width=1
						view.drawing_color= (@mirror_mode==1 || @ctrl_press) ? "blue" : "red"
						view.draw_lines @edge_preview.flatten
					end
					self.setstatus
			end
			def set_pointonedge(x,y,view,ip,edge)
				p1=edge.start.position.clone
				p2=edge.end.position.clone
				return nil if edge.length < (view.pixels_to_model(100*@scale_factor, p1))
				points= [Geom.linear_combination(2.0/3, p1,1.0/3, p2),Geom.linear_combination(1.0/3, p1,2.0/3, p2)]
				ph = view.pick_helper
				ph.init(x, y)
				pickeds = points.find_all{|p| ph.test_point((p.transform ip.transformation),x,y,@snap) }
				if pickeds
					pickeds.each{|picked|
						model=view.model
						ray=view.pickray x, y
						if ray
							ray=[picked,ray[1].reverse!]
							item=model.raytest(ray,false)
							if !item
								ip1=Sketchup::InputPoint.new(picked.transform ip.transformation)
								ip.copy! ip1
								view.tooltip=Strings["1/3"]
								point=picked.transform ip.transformation
								return point
							end
						end
					}
				end
				return nil
			end
			def set_special_point(x,y,view,ip)
				sels=view.model.selection.select{|e| e.valid? && (e.is_a?(Sketchup::Group) || e.is_a?(Sketchup::ComponentInstance) || e.is_a?(Sketchup::Image))}
				points=[]
				best_entity = sels.sort_by{|e| view.screen_coords(e.bounds.center).distance view.screen_coords(ip.position) }
				best_entity=best_entity[0..7].select{|e| e.valid? && (e.is_a?(Sketchup::Group) || e.is_a?(Sketchup::ComponentInstance) )}
				if !best_entity.empty?
					best_entity.each{|e|
						ps = get_bounds(e)
						points+=ps
						ps.permutation(2).to_a.each{|a|  points << Geom.linear_combination(0.5, a[0],0.5,a[1]) }
						# get_lines_bounds(e).each{|a|  points << Geom.linear_combination(0.5, a[0],0.5,a[1]) }
					}
				end
				points.uniq!
				ph = view.pick_helper
				ph.init(x, y)
				ph.do_pick(x, y)
				picked_bounds = points.find_all{|p| ph.test_point(p,x,y,1.5*@snap) }
				if picked_bounds
					picked_bounds.each{|picked|
						model=view.model
						ray=view.pickray x, y
						if ray
							ray=[picked,ray[1].reverse!]
							item=model.raytest(ray,false)
							if !item
								ip1=Sketchup::InputPoint.new(picked)
								ip.copy! ip1
								view.tooltip=Strings["BoundingBox"]
								return picked
							end
						end
					}
				end
				if ip.edge
					@edge=set_pointonedge(x,y,view,ip,ip.edge)
				end
			end
			def get_bounds(element)
				b=nil
				if element.is_a?Sketchup::ComponentInstance
					b=element.definition.bounds
				elsif element.is_a?Sketchup::Group
					b=element.local_bounds
				elsif element.is_a?Sketchup::Image
					b=element.bounds
				else
					return nil
				end
				return (0..7).collect{|i| b.corner(i).clone.transform element.transformation } if b
			end
			def onMouseMove(flags, x, y, view)
				@shift_press= (CONSTRAIN_MODIFIER_MASK&flags==CONSTRAIN_MODIFIER_MASK)
				@ctrl_press= (COPY_MODIFIER_MASK&flags==COPY_MODIFIER_MASK)
				@alt_press= (ALT_MODIFIER_MASK&flags==ALT_MODIFIER_MASK)
                @edge_preview=[]
				@edge=nil
                @trans=nil
                @point=nil
				ph = view.pick_helper
				ph.do_pick(x, y)
				e=ph.best_picked
				if view.model.selection.empty? && (@elements.empty? && @entities.empty?)
					if e && e.is_a?(Sketchup::Drawingelement)
						view.model.selection.add e
						self.reset(view)
					end
				else
					if @state==0
						@ip.pick view,x,y
						view.tooltip = @ip.tooltip
						if @plane_type==2 || @alt_press
							@edge=set_pointonedge(x,y,view,@ip,@ip.edge) if @ip && @ip.edge
						else
							@point=set_special_point(x,y,view,@ip)
						end
						face=@ip.face
						@trans=@ip.transformation
						ph.do_pick(x, y)
						element=ph.best_picked
                        @lines=[]
                        @elements.each{|e|
                        @lines+= get_lines_bounds(e) }
						ip1 = view.inputpoint(x, y,Sketchup::InputPoint.new(@edit_transform.origin))
						p=ip1.position.transform @edit_transform.inverse
						if (!@shift_press || !@plane_transform)
                            @plane_transform=nil
							if @ip.edge
								line=(@ip.edge.end.position.transform(@trans)-@ip.edge.start.position.transform(@trans))
								line.reverse! if view.screen_coords(@ip.edge.start.position.transform(@trans)).x> view.screen_coords(@ip.edge.end.position.transform(@trans)).x
								if @edit_transform.zaxis.parallel? line
									normal=@edit_transform.zaxis
								else
									normal=line.cross @edit_transform.zaxis
								end
								@plane_transform=Geom::Transformation.new(@ip.position,normal)
							elsif element.is_a?(Sketchup::ConstructionLine)
								p=ORIGIN
								p1=p+element.direction
								line=p1-p
								line.reverse! if view.screen_coords(p1).x< view.screen_coords(p).x
								if @edit_transform.zaxis.parallel? line
									normal=@edit_transform.zaxis
								else
									normal=line.cross @edit_transform.zaxis
								end
								@plane_transform=Geom::Transformation.new(@ip.position,normal)
								view.tooltip=Strings["ConstructionLine"]
							elsif (p.y==0) || (p.x==0)
								vector =@edit_transform.origin.vector_to ip1.position
								if vector.length>0
									vz=vector.cross @edit_transform.zaxis
									if vz.length>0
										@plane_transform=Geom::Transformation.new(ip1.position,vz)
										view.tooltip=Strings["Axis"]
									end
								end
							elsif @ip.face
								normal=S4U::S4u_mirror.normal_face(face,@trans)
								@plane_transform=Geom::Transformation.new(@ip.position,normal)
							elsif element.is_a?Sketchup::SectionPlane
								plane = element.get_plane.to_a
								normal=Geom::Vector3d.new(plane[0],plane[1],plane[2])
								@plane_transform=Geom::Transformation.new(@ip.position,normal)
							end
							@plane_transform=@edit_transform if !@plane_transform
						end
						if @shift_press
							@plane_transform=Geom::Transformation.new(@ip.position,@plane_transform.zaxis)
						end
						if (@plane_type==2 || @alt_press)
							if @plane_transform
								@plane=[@plane_transform.origin,@plane_transform.zaxis]
								preview_mirror(@plane)
							end
						end
						view.invalidate if @ip.valid?
					elsif @state==1
						@ip.pick view,x,y,@ip1
						view.tooltip = @ip.tooltip
						@point=set_special_point(x,y,view,@ip)
						if	@ip1.valid? && @ip.valid? && @ip.position.distance(@ip1.position)>0
							if @middle_points
								if @points.length==1
									points=[@points[0],@ip.position]
									p =[(points[0][0]+points[1][0])*0.5,(points[0][1]+points[1][1])*0.5,(points[0][2]+points[1][2])*0.5]
									@ip2=Sketchup::InputPoint.new(p)
								else
									@ip2.copy! @ip
								end
							elsif @points.empty?
								@ip2.copy! @ip
							end
							if @ip2.valid? && @ip1.valid?  && @plane_type!=2
								@line45=nil
                                li= @lines.select{|l| l[0].distance(l[1])>0}.min_by{|d| @ip2.position.distance_to_line([d[0],(d[0].vector_to d[1])])  }
                                if li
                                    vec=li[0].vector_to li[1]
                                    v1=vec.transform Geom::Transformation.rotation(li[0], Z_AXIS, Math::PI*0.25)
                                    v2=vec.transform Geom::Transformation.rotation(li[0], Z_AXIS.reverse, Math::PI*0.25)

                                    line451=[@ip1.position,v1]
                                    line452=[@ip1.position,v2]
                                    line_axis1=[@ip1.position,(X_AXIS+Y_AXIS)]
                                    line_axis2=[@ip1.position,(X_AXIS.reverse + Y_AXIS)]

                                    if li45=[line451,line452].find{|d| @ip2.position.distance_to_line(d)<=@snap}
                                        po = @ip2.position.project_to_line li45
                                        if ph.test_point(po,x,y,3*@snap)
                                            ip_temp= Sketchup::InputPoint.new(po)
                                            @ip2.copy! ip_temp
                                            view.tooltip=Strings["On Mirror 45"]
											@line45=li45
                                        end
                                    elsif li45=[line_axis1,line_axis2].find{|d| @ip2.position.distance_to_line(d)<=@snap}
                                        po = @ip2.position.project_to_line li45
                                        if ph.test_point(po,x,y,3*@snap)
                                            ip_temp= Sketchup::InputPoint.new(po)
                                            @ip2.copy! ip_temp
                                            view.tooltip=Strings["On Axis 45"]
											@line45=li45
                                        end
                                    end
                                end
								p1=@ip1.position
								p2=(@p_shift && @shift_press) ? @p_shift : @ip2.position
								vx= p1.vector_to p2
								vz=Z_AXIS
								vy=vz.cross vx
								ray=view.pickray x, y
								if ray && (vy.length==0  || ([X_AXIS,Y_AXIS,Z_AXIS].find{|vz| ray[1].parallel?(vz)}))
									vec= p1.vector_to p2
									vy=ray[1].cross(vec)
									normal=vec.cross ray[1]
									if normal.length>0
										@plane=[p1,normal]
										preview_mirror(@plane)
									end
								else
									@plane=[p1,vy]
									preview_mirror(@plane)
								end
							end
						end
						view.invalidate if @ip.valid?
					elsif @state==2
						ip=(@ip.position.distance(@ip1.position) < @ip.position.distance(@ip2.position)) ? @ip1 : @ip2
						@ip.pick view,x,y,ip
						view.tooltip = @ip.tooltip
						@point=set_special_point(x,y,view,@ip)
						if @middle_points
							if @points.length==1
								points=[@points[0],@ip.position]
								p =[(points[0][0]+points[1][0])*0.5,(points[0][1]+points[1][1])*0.5,(points[0][2]+points[1][2])*0.5]
								@ip3=Sketchup::InputPoint.new(p)
							else
								@ip3.copy! @ip
							end
						elsif @points.empty?
							@ip3.copy! @ip
						end
						if @ip1.valid? && @ip2.valid? && @ip3.valid? &&
							(@ip1.position.distance(@ip2.position))>0 &&
							(@ip2.position.distance(@ip3.position))>0 &&
							(@ip1.position.distance(@ip3.position))>0
							p1=@ip1.position
							p2=@ip2.position
							p3=@ip3.position
							vx= p1.vector_to p2
							p3_line=p3.project_to_line [p1,p2]
							vy=p3_line.vector_to p3
							vz=vy.cross vx
							if vz.length>0
								@plane=[p1,vz]
								preview_mirror(@plane)
							end
						end
						view.invalidate if @ip.valid?
					end
				end
			end
			def onLButtonDown(flags, x, y, view)
				if @state==0
					if @ip.valid?
						if @middle_points && @points.length<2
							@points<<@ip.position
						end
						if !@middle_points || @points.length==2
							if @middle_points
								p =[(@points[0][0]+@points[1][0])*0.5,(@points[0][1]+@points[1][1])*0.5,(@points[0][2]+@points[1][2])*0.5]
								@ip=Sketchup::InputPoint.new(p)
								@points.clear
								@middle_points=false
							end
							if @plane_type==2 || @alt_press
								process_mirror(@plane) if @plane
								view.model.select_tool nil
							else
								@ip1.copy! @ip
								@point1=@ip1.position
								@state=1
							end
						end
						view.invalidate
					end
				else
					if (@state==1) && @ip.valid?
						if @middle_points && @points.length<2
							@points<<@ip.position
						end
						if !@middle_points || @points.length==2
							if @middle_points
								p =[(@points[0][0]+@points[1][0])*0.5,(@points[0][1]+@points[1][1])*0.5,(@points[0][2]+@points[1][2])*0.5]
								@ip2=Sketchup::InputPoint.new(p)
								@points.clear
								@middle_points=false
							end
							if @plane_type==0
								process_mirror(@plane) if @plane
								view.model.select_tool nil
							elsif @plane_type==1
								@state=2
							end
						end
						view.invalidate
					elsif @state==2 && @plane_type==1 && @ip.valid?
						if @middle_points && @points.length<2
							@points<<@ip.position
						end
						if !@middle_points || @points.length==2
							if @middle_points
								p =[(@points[0][0]+@points[1][0])*0.5,(@points[0][1]+@points[1][1])*0.5,(@points[0][2]+@points[1][2])*0.5]
								@ip3=Sketchup::InputPoint.new(p)
								@points.clear
								@middle_points=false
							end
							if @ip1.valid? && @ip2.valid? && @ip3.valid?
								@ip1.position.distance(@ip2.position)>1 &&
								@ip1.position.distance(@ip3.position)>1 &&
								@ip2.position.distance(@ip3.position)>1
								process_mirror(@plane) if @plane
								view.model.select_tool nil
							end
						end
					end
				end
				self.setstatus(view)
				rescue=>error
				    p error,error.backtrace.join('\n')
				    self.reset(view)
			end
			def process_mirror(plane)
				model=Sketchup.active_model
				entities=model.active_entities
				@elements.select!{|e| e && e.valid?}
				@entities.select!{|e| e && e.valid?}
				return if @elements.empty? && @entities.empty?
				model.start_operation TOOL,true,false,false
				begin
					t_mirror=Geom::Transformation.new plane[0],plane[1]
					t_scale=Geom::Transformation.scaling 1,1,-1
					if (@mirror_mode==1 || @ctrl_press)
						model.selection.clear
						@elements.each{|e|
							if e.is_a?Sketchup::ComponentInstance
								g=entities.add_instance e.definition,t_mirror*t_scale*t_mirror.inverse*e.transformation
								if g && g.valid?
									set_attribute_element(e,g)
									model.selection.add(g)
								end
							elsif e.is_a?Sketchup::Group
								g=e.copy
								g.transformation=t_mirror*t_scale*t_mirror.inverse*g.transformation
								if g && g.valid?
									set_attribute_element(e,g)
									model.selection.add(g)
								end
							elsif e.is_a?Sketchup::Image
								g=entities.add_image(e.path,e.origin,e.width,e.height)
								g.transformation=t_mirror*t_scale*t_mirror.inverse*g.transformation
								if g && g.valid?
									model.selection.add(g)
									set_attribute_element(e,g)
								end
							end
						}
						if @entities && !@entities.empty?
							element=entities.add_group @entities
							g=element.copy
							g.transformation=t_mirror*t_scale*t_mirror.inverse*g.transformation
							ent=g.explode.select{|e| e && e.valid? && e.is_a?(Sketchup::Drawingelement)}
							model.selection.add(ent) if ent
							element.explode
						end
					elsif @mirror_mode==0
						@elements.each{|e|
							e.transformation=t_mirror*t_scale*t_mirror.inverse*e.transformation
							model.selection.add(e)
						}
						if @entities && !@entities.empty?
							g=entities.add_group @entities
							g.transformation=t_mirror*t_scale*t_mirror.inverse*g.transformation
							ent=g.explode.select{|e| e && e.valid? && e.is_a?(Sketchup::Drawingelement)}
							model.selection.add(ent) if ent
						end
					end
				model.commit_operation
				self.setstatus
				rescue=>error
					p error,error.backtrace.join('\n')
					model.abort_operation
				end
			end
			def get_lines_bounds(element)
				b=get_bounds(element)
				if b
					return [[b[0],b[1]],[b[1],b[3]],[b[2],b[3]],[b[2],b[0]],
							[b[4],b[5]],[b[5],b[7]],[b[6],b[7]],[b[6],b[4]],
							[b[0],b[4]],[b[1],b[5]],[b[2],b[6]],[b[3],b[7]]]
				end
			end
			def preview_mirror(plane)
				@edge_preview=[]
				model=Sketchup.active_model
				entities=model.active_entities
				return if @elements.empty? && @entities.empty?
				t_mirror=Geom::Transformation.new plane[0],plane[1]
				t_scale=Geom::Transformation.scaling 1,1,-1
				ed=[]
				bounds=[]
				(@elements+@entities).each{|e|
					if e.is_a?(Sketchup::Edge)
						ed<<e
					elsif e.is_a?(Sketchup::Face)
						ed+=e.edges
					elsif e.is_a?(Sketchup::Group) || e.is_a?(Sketchup::ComponentInstance) || e.is_a?(Sketchup::Image)
						bounds+=get_lines_bounds e
					end
				}
				ed.uniq!
				bounds.uniq!
				@edge_preview+=bounds.collect{|e| [e[0].transform(t_mirror*t_scale*t_mirror.inverse),
							e[1].transform(t_mirror*t_scale*t_mirror.inverse)] }
				@edge_preview+=ed.collect{|e| [e.start.position.transform(t_mirror*t_scale*t_mirror.inverse),
							e.end.position.transform(t_mirror*t_scale*t_mirror.inverse)]}
			end
			def getMenu(menu)
				menus=[]
				@mirror_mode_list.each_index{|i| menus<< menu.add_item(@mirror_mode_list[i]) {@mirror_mode=i }}
				menus.each{|m| menu.set_validation_proc(m) { MF_UNCHECKED }}
				menu.set_validation_proc(menus[@mirror_mode]) { MF_CHECKED }
				menu.add_separator
				menus=[]
				@plane_type_list.each_index{|i| menus<< menu.add_item(@plane_type_list[i]) {@plane_type=i }}
				menus.each{|m| menu.set_validation_proc(m) { MF_UNCHECKED }}
				menu.set_validation_proc(menus[@plane_type]) { MF_CHECKED }
				menu.add_separator
				menus=[]
				menus<< menu.add_item(Strings["Middle From 2 Points"]) { @middle_points=true }
			end
			def onKeyDown(key, repeat, flags, view)
				if @plane_type==2
					if (key==CONSTRAIN_MODIFIER_KEY)
						@shift_press=true
					elsif ((key==VK_CONTROL) && IS_WIN ) || ((key==VK_ALT) && IS_OSX)
						@ctrl_press=true
					elsif (key==VK_ALT && IS_WIN )|| ((key==VK_CONTROL) && IS_OSX)
						@alt_press=true
					end
				else
					if key==CONSTRAIN_MODIFIER_KEY
						@shift_press=true
						if( @state==0 && @ip.valid? )
							view.lock_inference @ip if !@alt_press
						elsif( @state==1 && @ip.valid?)
							@p_shift=@ip.position
							view.lock_inference @ip if !@alt_press
						elsif( @state==2 && @ip.valid?)
							@p_shift=@ip.position
							view.lock_inference @ip if !@alt_press
						end
						self.setstatus(view)
					elsif key==VK_UP
						view.lock_inference if view.inference_locked?
						if @ip.valid? && @state>0
							p= ((@state==1) ? @ip1.position : @ip2.position)
							p1=p + @edit_transform.zaxis
							ip1 = Sketchup::InputPoint.new(p1)
							ip = Sketchup::InputPoint.new(p)
							view.lock_inference ip1,ip
						end
					elsif key==VK_LEFT
						view.lock_inference if view.inference_locked?
						if @ip.valid? && @state>0
							p=  ((@state==1) ? @ip1.position : @ip2.position)
							p1=p + @edit_transform.yaxis
							ip1 = Sketchup::InputPoint.new(p1)
							ip = Sketchup::InputPoint.new(p)
							view.lock_inference ip1,ip
						end
					elsif key==VK_RIGHT
						view.lock_inference if view.inference_locked?
						if @ip.valid? && @state>0
							p= ((@state==1) ? @ip1.position : @ip2.position)
							p1=p + @edit_transform.xaxis
							ip1 = Sketchup::InputPoint.new(p1)
							ip = Sketchup::InputPoint.new(p)
							view.lock_inference ip1,ip
						end
					elsif ((key==VK_CONTROL) && IS_WIN ) || ((key==VK_ALT) && IS_OSX)
						@ctrl_press=true
					elsif (key==VK_ALT && IS_WIN )|| ((key==VK_CONTROL) && IS_OSX)
						@alt_press=true
                        return true
					end
				end
			end
			def onKeyUp(key, repeat, flags, view)
				if @plane_type==2
					if (key==CONSTRAIN_MODIFIER_KEY)
						view.lock_inference if view.inference_locked?
						@shift_press=nil
					elsif ((key==9)) || ((key==48) && IS_OSX)
						(@mirror_mode=1-@mirror_mode)
						self.setstatus(view)
					elsif ((key==VK_CONTROL) && IS_WIN ) || ((key==VK_ALT) && IS_OSX)
						@ctrl_press=nil
					elsif (key==VK_ALT && IS_WIN )|| ((key==VK_CONTROL) && IS_OSX)
						@alt_press=nil
                        return true
					end
				else
					if (key==CONSTRAIN_MODIFIER_KEY)
						view.lock_inference if view.inference_locked?
						@p_shift=nil
						@shift_press=nil
					elsif ((key==9)) || ((key==48) && IS_OSX)
						@mirror_mode=1-@mirror_mode
						self.setstatus(view)
					elsif ((key==VK_CONTROL) && IS_WIN ) || ((key==VK_ALT) && IS_OSX)
						@ctrl_press=nil
					elsif (key==VK_ALT && IS_WIN )|| ((key==VK_CONTROL) && IS_OSX)
                        @alt_press=nil
                        @edge_preview.clear
                        self.setstatus(view)
                        return true
					end
				end
			end
			def onCancel(reason, view)
				self.reset(view)
			end
			def reset(view=nil)
				@state=0
				@ip1.clear
				@ip2.clear
				@ip3.clear
				@ip.clear
				@trans=nil
				@plane=nil
				@edge_preview=[]
				if view
					view.lock_inference
					@elements=view.model.selection.to_a.select{|e|
                        e && e.valid? && (e.is_a?(Sketchup::Group) || e.is_a?(Sketchup::ComponentInstance) || e.is_a?(Sketchup::Image))}
					@entities=view.model.selection.to_a.select{|e|
                        e && e.valid? && (e.is_a?(Sketchup::Drawingelement))} - @elements
					@entities+=view.model.selection.to_a.select{|e|
                        e if e && e.valid? && e.is_a?(Sketchup::Face)}.collect{|f| f.edges}.flatten.uniq
					@entities=@entities.flatten.compact.uniq
				end
				self.setstatus(view)
			end
			def resume(view)
				self.setstatus(view)
			end
			def set_attribute_element(v,element)
				if  v && element && v.valid? && element.valid?
					element.layer=v.layer
					element.hidden=v.hidden?
					element.material=v.material
					element.casts_shadows=v.casts_shadows?
					element.receives_shadows=v.receives_shadows?
				end
			end
		end
		def self.normal_face(face,t=Sketchup.active_model.edit_transform)
			vx=nil;vy=nil;line=nil
			ver=face.outer_loop.vertices.collect{|v| v.position.transform t}
			(0..ver.length-2).each{|i|
				vx=ver[i].vector_to ver[i+1]
				line=ver[i],ver[i+1]
				if vx.length!=0 && line
					(0..ver.length-1).each{|i|
						v2=ver[i].project_to_line line
						vy=v2.vector_to ver[i]
						break if vy.length!=0
					}
					normal=vx.cross vy if vx && vy
					if normal.length!=0
						facenormal=face.normal.transform t
						normal.reverse! if (normal.angle_between facenormal) >= Math::PI*0.5
						return normal
					end
				end
			}
			return face.normal
		end
		def self.main(mirror_mode=0)
			Sketchup.active_model.select_tool Mirror.new(mirror_mode)
		end
	end
end